<?php
/**
 * Copyright © MagePal LLC. All rights reserved.
 * See COPYING.txt for license details.
 * http://www.magepal.com | support@magepal.com
*/

namespace WeLoveCustomers\Connector\Block\Adminhtml\System\Config;


class Versionnumber extends \Magento\Config\Block\System\Config\Form\Field
{
	public function getApiKey(){
	   $objectManager =  \Magento\Framework\App\ObjectManager::getInstance();
       $apikey = $objectManager->get('Magento\Framework\App\Config\ScopeConfigInterface')->getValue('welovecustomersconnector/general/api_key');
        return $apikey;
    }

    public function getApiGlue(){
        $objectManager =  \Magento\Framework\App\ObjectManager::getInstance();
        $apiGlue = $objectManager->get('Magento\Framework\App\Config\ScopeConfigInterface')->getValue('welovecustomersconnector/general/api_glue');
        return $apiGlue;
    }


	public function getExtensionVersion()
    {
        $objectManager =  \Magento\Framework\App\ObjectManager::getInstance();
        $versionInfo =  $objectManager->get('Magento\Framework\Module\ModuleList')->getOne('WeLoveCustomers_Connector');
        $versionextension = $versionInfo['setup_version']; 
        return $versionextension;

    }

    public function getApiUrl(){
	 	return "https://app.welovecustomers.fr/api/";
	}

    public function callApi($service, $content){
        $content = http_build_query($content);

        $context_options = array (
            'http' => array (
                'method' => 'POST',
                'header'=> "Content-type: application/x-www-form-urlencoded\r\n"
                    . "Content-Length: " . strlen($content) . "\r\n",
                'content' => $content
            )
        );

        $context = stream_context_create($context_options);
         $endPoint =  $this->getApiUrl() . $service . "/";

        $fp = @fopen($endPoint, 'r', false, $context);
        $response = false;
        if ($fp){
            while (($buffer = fgets($fp, 4096)) !== false) {
                $response .= $buffer;
            }
            if (!feof($fp)) {
            }
            fclose($fp);

        }

        return $response;
    }

  protected function _getElementHtml(\Magento\Framework\Data\Form\Element\AbstractElement $element)
	{
	 $version = "Api not called";
        if ($apiKey = $this->getApiKey()) {
            $callData = array(
                'customerKey' => $apiKey
            );

            $response = $this->callApi('magento2PluginVersion', $callData);
            if ($response) {
                $objResponse = json_decode($response);
                $version = $objResponse->version;
            }
        }	
		return __('Module version %1 (latest  version available: %2)', $this->getExtensionVersion(), $version);
	}
}
