<?php


namespace WeLoveCustomers\Connector\Block\Checkout\Onepage\Success;

use Magento\Framework\View\Element\Template;
use Magento\Framework\View\Element\Template\Context;

class Tag extends \Magento\Checkout\Block\Onepage\Success
{
    protected $orderRepository;
    protected $orderFactory;
    protected $renderer;
    /**
     * @param \Magento\Framework\View\Element\Template\Context $context
     * @param \Magento\Checkout\Model\Session $checkoutSession
     * @param \Magento\Sales\Model\Order\Config $orderConfig
     * @param \Magento\Framework\App\Http\Context $httpContext
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context, 
        \Magento\Checkout\Model\Session $checkoutSession, 
        \Magento\Sales\Model\Order\Config $orderConfig, \Magento\Framework\App\Http\Context $httpContext, 
        \Magento\Sales\Api\OrderRepositoryInterface $orderRepository, 
        \Magento\Sales\Api\Data\OrderInterfaceFactory $orderFactory, 
        \Magento\Sales\Model\Order\Address\Renderer $renderer, 
        array $data = []
    ) {
        $this->orderRepository = $orderRepository;
        $this->orderFactory = $orderFactory;
        $this->renderer = $renderer;
        parent::__construct(
                $context, $checkoutSession, $orderConfig, $httpContext, $data
        );
    }

    public function getOrder($id) {
        $order = false;
        try{
            $order = $this->orderRepository->get($id);
        } catch (Exception $e){
            $order = $this->orderFactory->create->loadByIncrementId($id);
        }
        return $order;
    }
    
}